import 'package:deuna_checkout_widget/src/models/models.dart';
import 'package:flutter/widgets.dart';

export 'package:deuna_checkout_widget/src/models/models.dart';

/// {@template deuna_checkout_widget.DeUnaCheckoutConfiguration}
/// The [DeUnaCheckoutConfiguration] provides a [DeUnaCheckoutData]
/// configuration.
/// {@endtemplate}
class DeUnaCheckoutConfiguration extends InheritedWidget {
  /// {@macro deuna_checkout_widget.DeUnaCheckoutConfiguration}
  const DeUnaCheckoutConfiguration({
    Key? key,
    required this.data,
    required Widget child,
  }) : super(key: key, child: child);

  /// The [DeUnaCheckoutData] configuration to provide.
  final DeUnaCheckoutData data;

  @override
  bool updateShouldNotify(DeUnaCheckoutConfiguration oldWidget) {
    return true;
  }

  /// Reads the [DeUnaCheckoutData] configuration from the widget tree.
  static DeUnaCheckoutData of(BuildContext context) {
    final widget = context
        .dependOnInheritedWidgetOfExactType<DeUnaCheckoutConfiguration>();
    if (widget == null) {
      throw FlutterError(
        '''
DeUnaCheckoutConfiguration.of() called with a context that does not contain a DeUnaCheckoutConfiguration.
No DeUnaCheckoutConfiguration ancestor could be found starting from the context that was passed to DeUnaCheckoutConfiguration.of().
This can happen if the context comes from a widget above the DeUnaCheckoutConfiguration, e.g., the context might be from a StatelessWidget.
In this case, there is nothing to do.        
''',
      );
    }
    return widget.data;
  }
}
