/// {@template deuna_checkout_widget.AnalyticsConfig}
/// Provides the analytics configuration.
/// {@endtemplate}
class AnalyticsConfig {
  /// {@macro deuna_checkout_widget.AnalyticsConfig}
  const AnalyticsConfig({
    this.sessionId,
    this.googleTagManagerKeyId,
    required this.amplitudeKeyId,
  });

  /// Session ID.
  final String? sessionId;

  /// Key id of the google tag manager.
  final String? googleTagManagerKeyId;

  /// Key id of amplitude.
  final String amplitudeKeyId;

  /// Convert [AnalyticsConfig] to json [Map].
  Map<String, dynamic> toJson() {
    return <String, dynamic>{
      if (sessionId != null) 'sessionId': sessionId,
      if (googleTagManagerKeyId != null)
        'googleTagManager': <String, dynamic>{'keyId': googleTagManagerKeyId},
      'amplitudeKeyId': <String, dynamic>{'keyId': amplitudeKeyId},
    };
  }
}
