import 'package:meta/meta.dart';

/// Server environment.
@immutable
class DeUnaCheckoutEnv {
  const DeUnaCheckoutEnv._(this.index, this.name, this.url);

  /// Index of the environment.
  final int index;

  /// Name of the environment.
  final String name;

  /// URL of the environment.
  final String url;

  /// Productions environment.
  static const prod = DeUnaCheckoutEnv._(
    0,
    'prod',
    'https://checkout-st.deuna.io/',
  );

  /// Staging environment.
  static const stg = DeUnaCheckoutEnv._(
    1,
    'stg',
    'https://staging-checkout-st.deuna.io/',
  );

  /// List of all environment values.
  static final values = <DeUnaCheckoutEnv>[
    DeUnaCheckoutEnv.prod,
    DeUnaCheckoutEnv.stg,
  ];
}
